
# S R V X 1

[[_TOC_]]

## Getting Started

Steps:
1. Request access
2. Access using SSH - [How to SSH / VNC / VPN](SSH-VPN-VNC/README.md)
3. Access using Teaching Hub - [How to connect using the TeachingHub](TeachingHub.md)
4. Access Services:
  - [Webdata](https://srvx1.img.univie.ac.at/webdata) - Hosting files
  - [Yopass](https://srvx1.img.univie.ac.at/secure) - Encrypted message service
  - [ECGateway](https://srvx1.img.univie.ac.at/ecmwf/ecmwf) (UNIVIE Network, [VPN](SSH-VPN-VNC/VPN.md))
  - [Transfer.sh](https://srvx1.img.univie.ac.at/filetransfer) ()
  - [iLibrarian](https://srvx1.img.univie.ac.at/)

## System Information
| Name | Value |
| --- | --- |
| Product | PowerEdge R940 |
| Processor | Intel(R) Xeon(R) Gold 6148 CPU @ 2.40GHz |
| Cores | 4 CPU,  20 physical cores per CPU, total 160 logical CPU units |
| CPU time | 700 kh | 
| Memory | 754 GB Total |
| Memory/Core | 9.4 GB |

```
----------------------------------------------
 131.130.157.11 _    .  ,   .           .
    *  / \_ *  / \_      _  *        *   /\'_
      /    \  /    \,   ((        .    _/  / 
 .   /\/\  /\/ :' __ \_  `          _^/  ^/  
    /    \/  \  _/  \-'\      *    /.' ^_   \
  /\  .-   `. \/     \ /==~=-=~=-=-;.  _/ \ -
 /  `-.__ ^   / .-'.--\ =-=~_=-=~=^/  _ `--./
/SRVX1   `.  / /       `.~-^=-=~=^=.-'      '
----------------------------------------------
```

## Services
The SRVX1 is the central access point to IMG services:
goto: [srvx.img.univie.ac.at](https://srvx1.img.univie.ac.at)
Currently running:
- TeachingHub (Jupyterhub)
- Webdata - File hosting
- YoPass - Password Sharing
- iLibrarian - Paper Management (development)
- Filetransfer.sh - File sharing service (development)

## Jupyterhub
<img src="Documentation/jupyterhub-logo.svg" width="300px">

SRVX1 serves a teaching [jupyterhub](https://jupyterhub.readthedocs.io/en/stable/) with a [jupyterlab](https://jupyterlab.readthedocs.io/en/stable/). It allows easy access for students and teachers.

Goto: [https://srvx1.img.univie.ac.at/hub](https://srvx1.img.univie.ac.at/hub)

Signup is only granted by teachers and requires a srvx1 user account. A new password is needed and a TOTP (time base one-time password) will be created. 

Download/Use any of these required Authenticator Apps:
 - [2FAS (Mobile, recommended)](https://2fas.com/)
 - [KeepassX (Desktop)](https://www.keepassx.org/)
 - [Authy (Mobile, Desktop)](https://authy.com/download/)
 - [FreeOTP (Mobile)](https://freeotp.github.io/)
 - [Google Auth (Mobile)](https://play.google.com/store/apps/details?id=com.google.android.apps.authenticator2)

After registering the teacher/admin has to grant you access and you can login.

## Software

The typcial installation of a intel-server has the INTEL Compiler suite (`intel-parallel-studio`, `intel-oneapi`) and the open source GNU Compilers installed. Based on these two different compilers (`intel`, `gnu`), there are usually two version of each scientific software.
Major Libraries:
 - OpenMPI (3.1.6, 4.0.5)
 - HDF5 
 - NetCDF (C, Fortran)
 - ECCODES from [ECMWF](https://confluence.ecmwf.int/display/ECC)
 - Math libraries e.g. intel-mkl, lapack,scalapack
 - Interpreters: Python, Julia
 - Tools: cdo, ncl, nco, ncview

These software libraries are usually handled by environment modules.

![](https://upload.wikimedia.org/wikipedia/en/thumb/0/0a/Environment_Modules_logo.svg/320px-Environment_Modules_logo.svg.png)

## Currently installed modules
Please note that new versions might already be installed.

```bash
$ module av
--------------- /home/swd/spack/share/spack/modules/linux-rhel8-skylake_avx512 ----------------
anaconda2/2019.10-gcc-8.4.1                         netcdf-fortran/4.5.3-gcc-8.4.1             
anaconda3/2020.07-gcc-8.4.1                         netlib-lapack/3.9.1-gcc-8.4.1              
anaconda3/2020.11-gcc-8.4.1                         netlib-lapack/3.9.1-intel-20.0.4           
anaconda3/2021.05-gcc-8.4.1                         netlib-lapack/3.9.1-oneapi-2021.2.0        
autoconf/2.69-oneapi-2021.2.0                       netlib-scalapack/2.1.0-gcc-8.4.1           
autoconf/2.71-oneapi-2021.2.0                       netlib-scalapack/2.1.0-gcc-8.4.1-MPI3.1.6  
eccodes/2.19.1-gcc-8.4.1                            openblas/0.3.17-gcc-8.4.1                  
eccodes/2.19.1-intel-20.0.4                         openmpi/3.1.6-gcc-8.4.1                    
eccodes/2.21.0-gcc-8.4.1                            openmpi/3.1.6-intel-20.0.4                 
eccodes/2.21.0-intel-20.0.4                         openmpi/4.0.5-gcc-8.4.1                    
geos/3.9.1-gcc-8.4.1                                openmpi/4.0.5-intel-20.0.4                 
hdf5/1.10.7-gcc-8.4.1-MPI3.1.6                      perl/5.32.0-intel-20.0.4                   
hdf5/1.10.7-intel-20.0.4-MPI3.1.6                   proj/8.1.0-gcc-8.4.1                       
hdf5/1.12.0-gcc-8.4.1                               python/3.8.9-gcc-8.4.1                     
hdf5/1.12.0-intel-20.0.4                            
hdf5/1.12.0-intel-20.0.4-MPI3.1.6                   
hdf5/1.12.0-oneapi-2021.2.0                         
intel-oneapi-compilers/2021.2.0-oneapi-2021.2.0     
intel-oneapi-dal/2021.2.0-oneapi-2021.2.0           
intel-oneapi-mkl/2021.2.0-oneapi-2021.2.0           
intel-oneapi-mpi/2021.2.0-oneapi-2021.2.0           
intel-parallel-studio/composer.2020.4-intel-20.0.4  
libemos/4.5.9-gcc-8.4.1                             
libemos/4.5.9-intel-20.0.4                          
matlab/R2020b-gcc-8.4.1                             
miniconda2/4.7.12.1-gcc-8.4.1                       
miniconda3/4.10.3-gcc-8.4.1                         
ncl/6.5.0-gcc-8.4.1-MPI3.1.6                        
ncl/6.6.2-gcc-8.4.1-MPI3.1.6                        
nco/4.9.3-gcc-8.4.1                                 
nco/4.9.3-intel-20.0.4                              
ncview/2.1.8-gcc-8.4.1                              
netcdf-c/4.6.3-gcc-8.4.1-MPI3.1.6                   
netcdf-c/4.6.3-intel-20.0.4-MPI3.1.6                
netcdf-c/4.7.4-gcc-8.4.1                            
netcdf-c/4.7.4-intel-20.0.4                         
netcdf-fortran/4.5.2-gcc-8.4.1-MPI3.1.6             
netcdf-fortran/4.5.2-intel-20.0.4-MPI3.1.6           
```
on how to use environment modules go to [Using Environment Modules](Misc/Environment-Modules.md)

## User services
There is a script collection that is accessible via the `userservices` command. e.g. running 
```bash
$ userservices

Usage: userservices [service] [Options]
Available Services:
------------------------------------------------------------------------
 archive              --- Submit files/folders to ZID Archive
 fetch-sysinfo        --- Display system information
 filesender           --- Transfer files to ACONET filesender (requires account)
 fix-permissions      --- fix file/directory permissions
 home-dir-check       --- Check home directory/configuration
 modules              --- Pretty print environment modules
 transfersh           --- Transfer files/directories (IMGW subnet)
 weather              --- Retrieve weather information
 yopass               --- Send messages/small files to YoPass (encrypted)
------------------------------------------------------------------------
These scripts are intended to help with certain known problems.
Report problems to: michael.blaschek@univie.ac.at

```
These are scripts in a common directory. Feel free to copy or edit as you like. Note that some services like filesender require an ACONET account (accessible via your u:account).


## Container Hub

Currently there is the possibility to run [singularity](https://singularity.hpcng.org/) containers on all our Servers. This is really similar to docker, but much more secure for multi-user servers. Almost every docker container can be converted into a singularity container. Some of the build recipes use docker.

There are a number of prepared containers but more can be added. If you have a wish or an existing container useful for others please share. 
```yaml
containers:
 - root: /home/swd/containers
 - available:
    - RTTOV:
      - RTTOV: 12.3
      - compiler: gcc:7.3.0 (anaconda)
      - path: /home/swd/containers/rttov-jupyter/jup3rttov.sif
      - os: centos:6.10
      - python: 3.7.4
      - singularity: 3.5.2
      - packages: 
        - anaconda3
        - jupyter jupyterlab numpy matplotlib pandas xarray bottleneck dask numba scipy netcdf4 cartopy h5netcdf nc-time-axis cfgrib eccodes nodejs
      - apps:
        - atlas
        - lab
        - notebook
        - rtcoef
        - rthelp
        - rttest
```
